/* confFile.c
 * Routines for Generic configuration
 * Copyright 2000, David Frascone <chaos@mindspring.com>
 *
 * $Id$
 * 
 * TODO:
 *           We should really read in the file once, and cache it.
 *
 * Ethereal - Network traffic analyzer
 * By Gerald Combs <gerald@zing.org>
 * Copyright 1998 Gerald Combs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#ifdef HAVE_CONFIG_H
# include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>

#ifdef HAVE_SYS_TYPES_H
# include <sys/types.h>
#endif

#ifdef HAVE_NETINET_IN_H
# include <netinet/in.h>
#endif

#ifdef NEED_SNPRINTF_H
# ifdef HAVE_STDARG_H
#  include <stdarg.h>
# else
#  include <varargs.h>
# endif
# include "snprintf.h"
#endif

#include <string.h>
#include <glib.h>
#include "config.h"

#define CONFIG_FILE_NAME "ethereal.conf"

char *
confGetConfiguration(char *package, char *dest, size_t destLen)
{
	FILE *fp;
	char searchStr[200];
	char buffer[1024];
	char filename[1024];

	snprintf(filename, 1023, "%s/%s", DATAFILE_DIR, CONFIG_FILE_NAME);

	fp = fopen(filename, "r");
	if (!fp) {
		dest[0]=0;
		return NULL;
	}

	snprintf(searchStr, 199, "%s:", package);

	while (fgets(buffer, 1023, fp) != NULL) {
		if (!strncmp(buffer, searchStr, strlen(searchStr))) {
			/* We found it! */
			strncpy(dest, &buffer[strlen(searchStr)+1], destLen);
			fclose(fp);
			return dest;
		}
	}
	
	fclose(fp);
	
	dest[0]=0;
	return NULL;
} /* confGetConfiguration */
